import { Component, OnInit, ViewChild, Type } from '@angular/core';
import { STComponent, STColumn, STChange } from '@delon/abc/st';
import { SFComponent, SFRadioWidgetSchema, SFSchema, SFUISchema } from '@delon/form';
import { NzModalService } from 'ng-zorro-antd/modal';
import { SystemService } from '../../services/system.service';

@Component({
  selector: 'app-crm-management',
  templateUrl: './crm-management.component.html',
  styleUrls: ['./crm-management.component.less']
})
export class CrmManagementComponent implements OnInit {
  @ViewChild('st', { static: true })
  st!: STComponent;
  @ViewChild('sf', { static: false }) sf!: SFComponent;
  @ViewChild('sfFre', { static: false }) sfFre!: SFComponent;
  ui: SFUISchema = {};
  ui2: SFUISchema = {};
  schema: SFSchema = {};
  addSchema: SFSchema = {};
  _$expand = false;
  editText = '';
  formData :any;
  isVisible = false;
  edit = false;
  editId = false;

  columns: STColumn[] = [
    { title: '客户名称', index: 'customerName' },
    { title: '客户简称', index: 'customerShortName' },
    { title: '客户编码', index: 'customerCode' },
    { title: '客户类型', render: 'customerType' },
    {
      title: '操作',
      buttons: [
        {
          text: '编辑',
          click: item => this.roleAction(item, 2)
        },
      ]
    }
  ];

  selectedRows: any[] = [];

  get reqParams (){ 
    return {
    ...this.sf?.value,
  }};

  constructor(public service: SystemService, private nzModalService: NzModalService) {}

  ngOnInit(): void {
    this.initSF()
    this.initSFFre()
  }

  stChange(e: STChange): void {
    switch (e.type) {
      case 'checkbox':
        this.selectedRows = e.checkbox!;
        break;
      case 'filter':
        this.st.load();
        break;
    }
  }
    /**
  * 伸缩查询条件
  */
     expandToggle(): void {
      this._$expand = !this._$expand;
      this.sf?.setValue('/_$expand', this._$expand);
    }
    /**
   * 查询字段个数
   */
     get queryFieldCount(): number {
      return Object.keys(this.schema?.properties || {}).length;
    }
  initSF(){
  this.schema = {
    properties: {
      _$expand: { type: 'boolean', ui: { hidden: true } },
      customerName: {
        type: 'string',
        title: '客户名称',
        ui: { placeholder: '请输入' }
      },
      customerShortName: {
        type: 'string',
        title: '客户简称',
        ui: { placeholder: '请输入' }
      },
      customerType: {
        type: 'string',
        title: '客户类型',
        enum: [
          { label: '客户', value: 1 },
          { label: '供应商', value: 2 },
        ],
        ui: { 
          widget: 'select'
         }
      },
      customerCode: {
        type: 'string',
        title: '客户编码',
        ui: { placeholder: '请输入',
        visibleIf: {
          _$expand: (value: boolean) => value
        } }
      },
    }
    
  };
  this.ui = { '*': { spanLabelFixed: 110, grid: { span: 8, gutter: 4 } } };
  }
  initSFFre() {
  this.addSchema = {
    properties: {
      customerName: {
        type: 'string',
        title: '客户名称',
        ui: { placeholder: '请输入' }
      },
      customerShortName: {
        type: 'string',
        title: '客户简称',
        ui: { placeholder: '请输入' }
      },
      customerCode: {
        type: 'string',
        title: '客户编码',
        ui: { placeholder: '请输入' }
      },
      customerType: {
        type: 'string',
        title: '客户类型',
        enum: [
          { label: '客户', value: 1 },
          { label: '供应商', value: 2 },
        ],
        ui: {
          widget: 'radio',
        } as SFRadioWidgetSchema,
        default: 1,
      },
  },
  required: ['customerName', 'customerShortName', 'customerType', 'customerCode']
  };
this.ui2 = { '*': { spanLabelFixed: 120, grid: { span: 24 } } };
}
  roleAction(value: any,item?: any) {
    if(item === 1) {
      this.edit = false;
      this.editText = '新增';
    } else {
      this.service.request(this.service.$api_get_crmCustomer, {id: value.id}).subscribe((res: any) => {
        console.log(res)
        if(res) {
          this.formData = res;
        }
      })
      this.edit = true;
      this.editId = value.id;
      this.editText = '编辑';
    }
   this.isVisible = true;
  }

  deleteAction(item?: any) {
    this.nzModalService.error({
      nzTitle: '确认删除？',
      nzClosable: false,
      nzCancelText: '取消',
      nzOnOk: () => {}
    });
  }

  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
  }
  handleCancel() {
    this.isVisible = false
  }

  handleOK() {
    console.log(this.sfFre.value)
    if(!this.sfFre.valid) {
      this.service.msgSrv.warning('请正确填写完整！')
      return
    }
    const params ={
      ...this.sfFre.value
    }
    if(this.editId) {
      params.id = this.editId
    }
    this.service.request(this.service.$api_save_crmCustomer, params).subscribe((res:any) => {
      if(res) {
    this.service.msgSrv.success('保存成功！')
    this.isVisible = false
    this.st.reload();
      } else {
    this.service.msgSrv.warning(res?.msg)

      }
    })
  }
}
